{-------------------------------------------------------------}
{
{    Programa de Transferncia Remota de Arquivos
{
{    Rotina para ler diretorio remoto
{
{    Autor: Jose' Antonio Borges
{
{    Em 21/04/98
{
{-------------------------------------------------------------}

unit ftpArq;
interface

uses dvCrt, dvWin, dvarq, dvform, sysUtils, winsock, winprocs,
     ftpVars, ftpMsg, ftpDlg, ftpPort, ftpRede;

procedure iniciaEnvio;
procedure iniciaRecepcao (nomeDesejado: string);
procedure apagaArquivo;

implementation

{-------------------------------------------------------------}
{                   inicia envio de arquivo
{-------------------------------------------------------------}

function selModo: boolean;
var c: char;
    modoTransm: char;
    codigo: integer;
begin
    selModo := false;

    mensagem ('FTMODIMG', 0);  {'Devo usar o modo imagem (sugiro que sim) ? '}
    c := sintReadkey;
    if c = ESC then
        begin
            mensagem ('FTDESIS', 2);   {'Desistiu'}
            exit;
        end;

    writeln (c);
    if upcase (c) = 'N' then
        modoTransm := 'A'
    else
        modoTransm := 'I';

    if enviaComando ('TYPE ' + modoTransm) then
        mostraRespostas (codigo)
    else
        begin
            mensagem ('FTERRMOD', 1);  {'Problemas ao selecionar modo de transmisso'}
            exit;
        end;

    selModo := true;
end;

{-------------------------------------------------------------}
{                   inicia envio de arquivo
{-------------------------------------------------------------}

procedure iniciaEnvio;
var codigo, ev: integer;
    s: string;
    continua: boolean;
    tituloJan: array [0..144] of char;

label fim, cancelaTudo;
begin
    textBackGround (MAGENTA);
    mensagem ('FTTRANSM', 0);  {'Transmitir'}
    textBackground (BLACK);
    writeln;

    mensagem ('FTNOMLOC', 0);  {'Qual o nome do arquivo local ? '}
    garanteEspacoTela(6);
    nomeArqLocal := obtemNomeArq(6);
    writeln (nomeArqLocal);
    if nomeArqLocal = '' then exit;

    assign (arqLocal, nomeArqLocal);
    {$I-}  reset (arqLocal, 1);  {$I+}
    if ioresult <> 0 then
        begin
            mensagem ('FTARQNAO', 1);  {'Arquivo no existe...'}
            exit;
        end;

    mensagem ('FTNOMREM', 0);  {'Qual o nome do arquivo remoto ? '}
    sintReadln (nomeArqHost);
    if nomeArqHost = '' then
        begin
            nomeArqHost := nomeArqLocal;
            while pos ('\', nomeArqHost) <> 0 do
                delete (nomeArqHost, 1, pos ('\', nomeArqHost));
            writeln ('(Assumindo ', nomeArqHost, ')');
        end;

    if not selModo then exit;

    if not modoPassivo then
        trocaPortaLocal
    else
        if not trocaPortaPassiva then exit;

    if not abreConexaoArq then
        goto cancelaTudo
    else
        begin
            totalTransmitido := 0;
            if enviaComando ('STOR ' + nomeArqHost) then
                begin
                    mostraRespostas (codigo);
                    if (codigo <> 125) and (codigo <> 150) then
                        begin
                            mensagem ('FTTRAREC', 1);  {'Transferncia de arquivo foi recusada'}
                            fechaConexaoArq;
                            exit;
                        end
                    else
                        begin
                            while (not eof (arqLocal)) and (processaTransf (ev)) do
                                begin
                                    enviaCanalArq;

                                    str ((totalTransmitido+1023) div 1024, s);
                                    strPCopy (tituloJan, 'FTPVOX ' + nomeHost + ' ' + s + 'K');
                                    setWindowText (crtWindow, tituloJan);

                                    if keypressed then
                                        case upcase (readkey) of
                                           #$1b:  if enviaComando ('ABOR') then
                                                       begin
                                                           mostraRespostas (codigo);
                                                           fechaConexaoArq;
                                                           exit;
                                                       end;
                                        else
                                            begin
                                                 mostraTransmitidos;
                                                 while keypressed do readkey;
                                            end;
                                        end;

                                    while pins <> pret do
                                        begin
                                            pegaResposta (s, codigo, continua);
                                            if (codigo <> 226) and (codigo <> 250) then
                                                begin
                                                    sintBip;
                                                    textColor (RED);
                                                    mensagem ('FTERRENV', 1);  {'Erro no envio dos dados, cdigo'}
                                                    sintWriteln (s);
                                                    textColor (WHITE);
                                                    goto fim;
                                                end;
                                        end;

                                end;
                        end;
                end;

        end;

    mensagem ('FTFIMENV', 1);  {'Envio completado'}
    strPCopy (tituloJan, 'FTPVOX ' + nomeHost);
    setWindowText (crtWindow, tituloJan);

fim:
    fechaConexaoArq;

    processaRede;
    mostraRespostas (codigo);

cancelaTudo:
    {$I-}  close (arqLocal);  {$I+}
    if ioresult <> 0 then;
end;

{-------------------------------------------------------------}
{                 inicia recepcao de arquivo
{-------------------------------------------------------------}

procedure iniciaRecepcao (nomeDesejado: string);
var i, ev, codigo: integer;
    s: string;
    tituloJan: array [0..144] of char;

label ok, fim;
begin
    textBackGround (MAGENTA);
    mensagem ('FTRECEBE', 0);  {'Receber'}
    textBackground (BLACK);
    writeln;

    if nomeDesejado = '' then
        begin
            mensagem ('FTNOMREM', 0);  {'Qual o nome do arquivo remoto ? '}
            sintReadln (nomeArqHost);
            if nomeArqHost = '' then exit;
        end
    else
        nomeArqHost := nomeDesejado;

    mensagem ('FTNOMLOC', 0);  {'Qual o nome do arquivo local ? '}
    sintReadln (nomeArqLocal);
    if nomeArqLocal = '' then
        begin
            nomeArqLocal := nomeArqHost;
            writeln ('(Assumindo nomes idnticos)');
        end;
    assign (arqLocal, nomeArqLocal);

    {$I-}  rewrite (arqLocal, 1);  {$I+}
    if ioresult <> 0 then
        begin
            mensagem ('FTNAOCRI', 1);  {'No consegui criar o arquivo local'}
            exit;
        end;

    if not selModo then exit;

    if not modoPassivo then
        trocaPortaLocal
    else
        if not trocaPortaPassiva then exit;

    if abreConexaoArq then
        begin
            totalTransmitido := 0;
            if enviaComando ('RETR ' + nomeArqHost) then
                begin
                    mostraRespostas (codigo);
                    if (codigo = 125) or (codigo = 150) then
                        goto ok;
                end;
        end;

    if codigo = 550 then
        begin
            mensagem ('FTARQNAO', 1);  {'Arquivo no existe...'}
            close (arqLocal);
            erase (arqLocal);
        end;

    mensagem ('FTTRAREC', 1);  {'Transferncia de arquivo foi recusada'}
    goto fim;

ok:
    while processaTransf (ev) do
        begin
            str ((totalTransmitido+1023) div 1024, s);
            strPCopy (tituloJan, 'FTPVOX ' + nomeHost + ' ' + s + 'K');
            setWindowText (crtWindow, tituloJan);

            if pins <> pret then
                mostraRespostas (codigo);

            if keypressed then
                case upcase (readkey) of
                   #$1b:  if enviaComando ('ABOR') then
                               begin
                                   mostraRespostas (codigo);
                                   exit;
                               end;
                else
                    begin
                         mostraTransmitidos;
                         while keypressed do readkey;
                    end;
                end;

            if ev = -1 then delay (100);   {deixa maquina mais leve}
        end;

    i := 0;
    repeat
         delay (500);
         processaTransf (ev);
         i := i + 1;
         if pins <> pret then
             mostraRespostas (codigo);
    until (pins <> pret) or (i > 10) or (codigo = 226) or (codigo = 250) or (codigo = 425);

    if (codigo <> 226) and (codigo <> 250) then
        begin
            sintBip;
            textColor (RED);
            mensagem ('FTERRENV', 1);  {'Erro no envio dos dados, cdigo'}
            sintWriteln (s);
            textColor (WHITE);
            goto fim;
        end;

    mensagem ('FTFIMREC', 1);  {'Recepo completada'}
fim:
    strPCopy (tituloJan, 'FTPVOX ' + nomeHost);
    setWindowText (crtWindow, tituloJan);
    fechaConexaoArq;
end;

{-------------------------------------------------------------}
{                         apaga um arquivo
{-------------------------------------------------------------}

procedure apagaArquivo;
var nome: string;
    codigo: integer;
begin
    mensagem ('FTAPAGA', 1);  {'Apagar'}
    mensagem ('FTNOMAPA', 0);  {'Qual o nome do arquivo remoto a apagar ? '}
    sintReadln (nome);
    if nome = '' then
        begin
            mensagem ('FTDESIS', 1);   { desistiu }
            exit;
        end;

    if enviaComando ('DELE ' + nome) then
        begin
            mostraRespostas (codigo);
            if (codigo = 125) or (codigo = 150) or (codigo = 250) then
                mensagem ('FTOKAPAG', 1)  {'Ok, apagado'}
            else
                mensagem ('FTNAOAPA', 1);  {'No consegui apagar este arquivo'}
        end;
end;

end.
